#ifndef __H_M_AFX_H__
#define __H_M_AFX_H__
//////////////////////////////////////////////////////////////////////////

#define LINUX

#ifdef LINUX
#undef WIN32
#undef MACOSX
#endif

#ifdef WIN32
#undef MACOSX
#undef LINUX
#endif

#ifdef MACOSX
#undef WIN32
#undef LINUX
#endif

////////

//#ifndef TEST
#define TEST 0
//#endif

////////
//
#define _FILE_OFFSET_BITS 64

//////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <stdarg.h>

#ifdef WIN32
#include <windows.h>
#include <direct.h>//for access & mkdir
#include <io.h>
#else
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>//for access & mkdir
#endif
//////////////////////////////////////////////////////////////////////////

#define Kbyte(x) (1024 * (x))
#define Mbyte(x) (1024 * 1024 * (x))
#define Gbyte(x) (1024 * 1024 * 1024 * (x))
#define Tbyte(x) (1024 * 1024 * 1024 * 1024 * (x))

#define Second(x) (x)
#define Minute(x) (x*60)
#define Hour(x) (x*3600)
#define Day(x) (x*3600*24)

#define xLOGBUFFERSIZE 1024 * 512
#define VLOG 1
#define VDBG 2
#define VERR 4
#define VALL 7

#define MINBUFFER_SIZE (256)
#define BUFFER_SIZE (4096)
#define BIGBUFFER_SIZE (1024 * 32)
#define HUGEBUFFER_SIZE (1024 * 256)


#ifndef INT_MAX
#define INT_MAX       (2147483647)    /* maximum (signed) int value */
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif

#ifndef null
#define null NULL
#endif

#ifndef Null
#define Null NULL
#endif

//
#ifndef FALSE
#define FALSE (0)
#endif

#ifndef False
#define False FALSE
#endif

#ifndef false
#define false FALSE
#endif

//
#ifndef TRUE
#define TRUE (1)
#endif

#ifndef Ture
#define Ture TRUE
#endif

#ifndef ture
#define ture ture
#endif

//
#ifndef lenof
#define lenof(x) ( (sizeof((x))) / (sizeof(*(x))))
#endif
//
#ifndef min
#define min(x,y) ( (x) < (y) ? (x) : (y) )
#endif
//
#ifndef max
#define max(x,y) ( (x) > (y) ? (x) : (y) )
#endif
//
#ifndef _start
#define _start do{
#endif
#ifndef _stop
#define _stop }while(0) ;
#endif

#define XRET_MASK 0xffff
#define XRET_ERRNO_MASK 0xffff0000

#define XRET_OK 1
#define XRET_FAILED 0
#define XRET_MEMLEEK -1
#define XRET_EXIST -2
#define XRET_NOT_EXIST -3
#define XRET_ENV_ERROR -4
#define XRET_PARAM_ERROR -5

#define XSPACE(x) ( ((x)=='\r') || ((x)=='\n') || ((x)=='\t') || ((x)==' ') )

typedef unsigned char u8 ;
typedef unsigned short u16 ;
typedef unsigned int u32 ;
typedef unsigned char * uptr ;
typedef char s8 ;
typedef short s16 ;
typedef int s32 ;
typedef char * sptr ;

typedef unsigned int uint;
typedef unsigned char uchar ;
typedef unsigned int unichar ;

#define IFCALL(_cb, ...) do { if (_cb != NULL) { _cb( __VA_ARGS__ ); } } while (0)
#define IFCALLRET(_cb, _ret, ...) do { if (_cb != NULL) { _ret = _cb( __VA_ARGS__ ); } } while (0)

#define RTL_NUMBER_OF_V1(A)	(sizeof(A) / sizeof((A)[0]))
#define RTL_NUMBER_OF_V2(A)	RTL_NUMBER_OF_V1(A)

#define ARRAYSIZE(A)		RTL_NUMBER_OF_V2(A)
#define _ARRAYSIZE(A)		RTL_NUMBER_OF_V1(A)

/* misc */
#define xxzero(p) memset ( (void *)&(p) , 0 , sizeof(p) ) ;
#define xzero(p,size) memset ( (void *)p , 0 , size ) ;

#define xfree(p) safefree((void **)&(p))
#define xmalloc(x) (char*)safemalloc((unsigned int)(x))
#define xralloc(x,y) (char*)saferalloc(x,(unsigned int)(y))

#define xnew(x) (x)
#define xdelete(x) (x)

#define XNULL(x) if((x)<=0){ return ; }
#define XXNULL(x,y) if((x)<=0){ return (y) ; }
#define XXNULLEX(x,y,z) if((x)<=0){(z); return (y) ; }
#define XXXNULL(x,y) if((x)<=0){ goto y ; }
#define XXXNULLEX(x,y,z) if((x)<=0){ (z); goto y ; }

/* memory */
void *saferalloc( void * oldmen , unsigned int size) ;
void *safemalloc(unsigned int size) ;
void safefree(void ** ptr) ;

/* str */
int xatoi ( char * a ) ;
char * xitoa ( int i , char * buffer ) ;
char * xltoa ( long long i , char * buffer ) ;
void xswap ( int * a , int * b ) ;

int xstr_en_de_xor(unsigned char * pbuf, int buf_len) ;

void xstrupper ( char * str ) ;
unsigned int xstr_hash (const char * v) ;

char * xstrdup ( const char * str ) ;
char * xstrndup ( char * str , int n ) ;
void * xmemdup ( void * mem , int n ) ;

#define xstrlen(x) (int)strlen(x)
#define xtolower(x) (((x)>='A'&&(x)<='Z')?(x)+('a'-'A'):(x))

int xstrlcat (char *dest, const char *src, int dest_size) ;
char * xstrconcat ( const char * s1 , ...) ;
char * xstrcpy ( char * ptr , char * s ) ;
int xstrlcpy (char *dest, const char *src, int dest_size) ;
int xstrcmp ( const char * , const char * );

char * xstrjoinv (const char * separator , char * * str_array ) ;

void xstrtidy ( char * str , char * gap ) ;
void xstrspaces ( char * str , char * spaces , int all ) ;
int xstr_has_prefix ( const char * str , const char * prefix ) ;
char * xstrstr_len (const char *haystack, int haystack_len, const char *needle) ;

int xstrcasecmp ( const char * a , const char * b ) ;
int xstrncasecmp ( const char * a , const char * b , int n ) ;
int xstr_match (const char *, const char *, int);
int xunicode_compare ( unsigned short * s , unsigned short * d ) ;

char * xstrdup_vprintf ( const char * format , va_list args ) ;
char * xstrdup_printf ( const char * format , ... ) ;
#define xsnprintf(str,size,format,...) str?(str)[(size)-1]=0,snprintf((str),(size)-1,(format),__VA_ARGS__):0

void xhex_str_to_bin(char* in, char* out, int out_len) ;
void xhex_to_bin(char* in, char* out) ;

/* file */
char * get_tmp_dir () ;
FILE * file_open ( char * filename , char * mode ) ;
FILE * file_open_tmp ( char * filename_tmpl , char ** ret_temp_filename ) ;

int file_path ( const char * filename , char path[BUFFER_SIZE] , char name[BUFFER_SIZE] ) ;
int file_write ( const char * buffer , int buffersize , char * filename , char * mode ) ;
int file_size ( char * filename ) ;
int file_content ( char ** data , int * size , char * filename ) ;
char * file_build_fullfilename (const char * path ,
                                const char * filename ,
                                const char * postfix ) ;
int file_isformat ( char * filename , char * format ) ;

int is_filepath_gap ( char gap ) ;
int xmake_dir ( char * dir , int mode ) ;
#define xaccess access
int ensure_exist ( char * path ) ;

/* misc */
int data_line ( char * data , int * index , char ** line ) ;
void hexdump(unsigned char *p, unsigned int len , char * tofile , char * flag ) ;

/* unicode ex */


int ascii_valid_str_pad ( char * str , int len , char pad ) ;
#define ascii_valid_str(m_afx_str) ascii_valid_str_pad(m_afx_str,(int)strlen(m_afx_str),0)

typedef enum {
  X_ASCII_ALNUM  = 1 << 0,
  X_ASCII_ALPHA  = 1 << 1,
  X_ASCII_CNTRL  = 1 << 2,
  X_ASCII_DIGIT  = 1 << 3,
  X_ASCII_GRAPH  = 1 << 4,
  X_ASCII_LOWER  = 1 << 5,
  X_ASCII_PRINT  = 1 << 6,
  X_ASCII_PUNCT  = 1 << 7,
  X_ASCII_SPACE  = 1 << 8,
  X_ASCII_UPPER  = 1 << 9,
  X_ASCII_XDIGIT = 1 << 10
} XAsciiType;

typedef enum
{
  X_UNICODE_CONTROL,
  X_UNICODE_FORMAT,
  X_UNICODE_UNASSIGNED,
  X_UNICODE_PRIVATE_USE,
  X_UNICODE_SURROGATE,
  X_UNICODE_LOWERCASE_LETTER,
  X_UNICODE_MODIFIER_LETTER,
  X_UNICODE_OTHER_LETTER,
  X_UNICODE_TITLECASE_LETTER,
  X_UNICODE_UPPERCASE_LETTER,
  X_UNICODE_SPACING_MARK,
  X_UNICODE_ENCLOSING_MARK,
  X_UNICODE_NON_SPACING_MARK,
  X_UNICODE_DECIMAL_NUMBER,
  X_UNICODE_LETTER_NUMBER,
  X_UNICODE_OTHER_NUMBER,
  X_UNICODE_CONNECT_PUNCTUATION,
  X_UNICODE_DASH_PUNCTUATION,
  X_UNICODE_CLOSE_PUNCTUATION,
  X_UNICODE_FINAL_PUNCTUATION,
  X_UNICODE_INITIAL_PUNCTUATION,
  X_UNICODE_OTHER_PUNCTUATION,
  X_UNICODE_OPEN_PUNCTUATION,
  X_UNICODE_CURRENCY_SYMBOL,
  X_UNICODE_MODIFIER_SYMBOL,
  X_UNICODE_MATH_SYMBOL,
  X_UNICODE_OTHER_SYMBOL,
  X_UNICODE_LINE_SEPARATOR,
  X_UNICODE_PARAGRAPH_SEPARATOR,
  X_UNICODE_SPACE_SEPARATOR
} XUnicodeType;

extern const unsigned short * const x_ascii_table;

#define x_ascii_isalnum(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_ALNUM) != 0)

#define x_ascii_isalpha(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_ALPHA) != 0)

#define x_ascii_iscntrl(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_CNTRL) != 0)

#define x_ascii_isdigit(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_DIGIT) != 0)

#define x_ascii_isgraph(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_GRAPH) != 0)

#define x_ascii_islower(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_LOWER) != 0)

#define x_ascii_isprint(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_PRINT) != 0)

#define x_ascii_ispunct(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_PUNCT) != 0)

#define x_ascii_isspace(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_SPACE) != 0)

#define x_ascii_isupper(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_UPPER) != 0)

#define x_ascii_isxdigit(c) \
((x_ascii_table[(uchar) (c)] & X_ASCII_XDIGIT) != 0)

extern const char * const xutf8_skip;

int xutf8_validate ( const char * str , int max_len , const char ** validend ) ;
unichar xutf8_get_char (const char *p) ;
#define xutf8_next_char(p) (char *)((p) + xutf8_skip[*(const uchar *)(p)])

int x_unichar_isalpha ( unichar c ) ;
int x_unichar_to_utf8 ( unichar c , char * outbuf) ;
//////////////////////////////////////////////////////////////////////////
#endif
