#ifndef __H_XLIST_H__
#define __H_XLIST_H__
/* include */
#include "m_afx.h"
#include "xchain.h"
/* macro */
#define XLIST_HASH_MAX 2713

#define XLIST_PTR 0
#define XLIST_STRING 1
#define XLIST_XLIST 2
/* define */
typedef struct _xlist
{
  int hash , type ;
  char * key ;
  char * value ;
  struct _xlist *prev ;
  struct _xlist *next ;
} xlist ;
typedef struct _xname_cache
{
  char *name;
  int occurences;
  struct _xname_cache *next;
  struct _xname_cache *prev;
} xname_cache ;

#define xlist_class_clean( xlst , type ) { xlist * x_class_clean_tmp = xlst ;while ( x_class_clean_tmp && ( x_class_clean_tmp ->next ) ){type * x_class_clean_tmp_type = (type *)x_class_clean_tmp ->value ; delete ( x_class_clean_tmp_type ) ;x_class_clean_tmp = x_class_clean_tmp ->next ;}	xlist_clean ( xlst ) ;}
#define xlist_class_reset( xlst , type ) { xlist * x_class_clean_tmp = xlst ;while ( x_class_clean_tmp && ( x_class_clean_tmp ->next ) ){type * x_class_clean_tmp_type = (type *)x_class_clean_tmp ->value ; delete ( x_class_clean_tmp_type ) ;x_class_clean_tmp = x_class_clean_tmp ->next ;}	xlist_reset ( xlst ) ;}

xlist * xlist_init () ;
void xlist_prepend ( xlist *xlst , const char * key , int type , char * value ) ;
void xlist_add ( xlist *xlst , const char * key , int type , char * value ) ;
xlist * xlist_get ( xlist *x , const char *key ) ;
int xlist_set ( xlist *xlst , const char * key , char *value ) ;
char * xlist_getv ( xlist * lst , const char *key ) ;
xlist * xlist_index ( xlist * lst , int idx ) ;
int xlist_size ( xlist *lst ) ;
#define xlist_isempty(xs) ((!xs)||((xs) ->prev == (xs)))
void xlist_exchange ( xlist * i , xlist * j ) ;
void xlist_qsort ( xlist * list , int (*compare)(xlist * , xlist *) ) ;
void xlist_reverse ( xlist *xs ) ;

void xlist_dump ( xlist *xs , int level ) ;
xlist * xlist_dup ( xlist *src ) ;
void xlist_clean ( xlist *x ) ;
void xlist_reset ( xlist *x ) ;

xlist * xlist_break ( xlist * xs , xlist *index ) ;
void xlist_delete ( xlist *xs , const char *key ) ;
xlist * xlist_pop ( xlist * xs ) ;
xlist * xlist_remove ( xlist * xs , const char * key ) ;

xlist * xlist_str2lst (char *str , char * gap) ;
void xlist_lst2str (xlist * xs , char ** data , int * len ) ;

char ** xstrsplit ( char *string, char *delimiter, int max_tokens ) ;
void xstrsplit_free (char ** xarray) ;

#define XPOINTER_TO_SIZE(p)	((size_t) (p))
#define XSIZE_TO_POINTER(s)	((void *)(size_t) (s))
#define XPOINTER_TO_INT(p)	((int) (p))
#define XINT_TO_POINTER(s)	((void)(int) (s))

#endif