#ifndef __H_LEG_SHARE_H__
#define __H_LEG_SHARE_H__

#define ONCE_TYPE (0)
#define ALWAYS_TYPE (1)

#define TCP_TRANS_TYPE (0)
#define UDP_TRANS_TYPE (1)

#define HEART_REPORT_TYPE (0)
#define AUDIT_REPORT_TYPE (1)
#define WARNNING_REPORT_TYPE (2)
#define STATUS_REPORT_TYPE (3)

/*
des:
   鱼爪初始化功能，当前主要获取鱼爪的功能类型
param:
   data[IN,OUT]:输入非空堆指针，值内容将被鱼爪修改
return:
   成功:返回大于等于0数字，即鱼爪功能类型
   失败:小于0
*/
typedef int (*octo_leg_init_handler)(void *data);
/*
des:
  鱼爪主要工作函数，一般为阻塞进程，阻塞时间直到停用此功能为止
param:
  data[IN,OUT]:输入空指针，输出鱼爪需要保存的信息，一般是需要鱼头帮助保存，释放时需要参与的结构体
return:
  成功:大于等于0（正常关闭）
  失败:小于0
*/
typedef int (*octo_leg_join_handler)(void *data);

/*
des:
  释放鱼爪功能
param:
  data[IN,OUT]:输入鱼爪暂存的指针信息，函数内部需要进程指针释放，输出为NULL指针
return:
  成功:大于等于0（正常关闭）
  失败:小于0
*/
typedef int (*octo_leg_free_handler)(void *data);

#pragma pack(push, 1)
// 鱼头和鱼爪的交互信息
typedef struct _st_octoShare
{
  // 鱼头执行文件所在路径
  char headPath[1024];
  // 鱼头监听端口
  int headListenPort;
  // 能力类型，0表示瞬时能力，1表示实时能力
  int runAlways;
  // 能力名
  char modeName[1024];
  // 鱼爪工作方法
  octo_leg_join_handler *join_handler;
  // 鱼爪释放方法
  octo_leg_free_handler *free_handler;
  // 拓展信息,一般存储鱼爪自定义的拓展结构体
  void *data;
} ST_octoShare, *PST_octoShare;
#pragma pack(pop)

#endif