#ifndef __LIB_H__
#define __LIB_H__

#include <arpa/inet.h>

/*
    功能:获取sm4加密和base结果
    参数:
        key:sm4的密钥
        value:代加密数据
        valueLen:代加密数据长度
        baseResult:数据加密后base64结果(堆区)
        baseResultLen:加密后数据长度
    返回值:
        0:成功
        -1:失败
*/
int get_sm4_and_base_enc_result(unsigned char *key, unsigned char *value, int valueLen, unsigned char **baseResult, int *baseResultLen);

/*
    功能:获取sm4解密结果
    参数:
        key:sm4的密钥
        value:待解密数据
        valueLen:待解密数据长度
        baseResult:解密结果
        baseResultLen:解密结果长度
    返回值:
        0:成功
        -1:失败
*/
int get_sm4_and_base_dec_result(unsigned char *key, unsigned char *value, int valueLen, unsigned char **baseResult, int *baseResultLen);

#endif