#ifndef __H_PACKET_H__
#define __H_PACKET_H__

#include "common.h"

#pragma pack(push, 1)
// 包头
typedef struct _st_packetHead
{
    // 数据长度，大端
    unsigned char clength[4];
    // 协议标识
    unsigned char protocolFlag[3];
    // 协议版本
    unsigned char protocolVer[2];
    // 加密类型
    unsigned char encodeType;
} ST_packetHead, *PST_packetHead;
#pragma pack(pop)

/*
des:
   检查机器的大小端
return:
   小端:1
   大端:0
*/
extern int check_big_little();

/*
des:
    解析鱼爪向鱼头汇报的信息
parm：
    recvStr[IN]:鱼爪向鱼头汇报的信息
    tcpJsonData[IN,OUT]:tcpJson消息
    udpJsonData[IN.OUT]:udpJson消息
retuen：
    成功:0
    失败:小于0

*/
int parse_leg_report_json(char *recvStr, cJSON *tcpJsonData, cJSON *udpJsonData);
/*
des:
    与管理平台通信的发送方法
param:
    socketFd[IN]:发送的套接字
    data[IN]:发送的数据内容
    datasize[IN]:发送的数据内容长度
return:
    成功:返回发送的字符串长度
    失败:小于0
*/
extern int psms_tcp_send(int socketFd, char *data, int datasize);
/*
des:
    与管理平台通信的数据接收方法
param:
    socketFd[IN]:接收套接字
    data[IN,OUT]:传入空字符串指针地址，返回接收的数据内容
    datasize[IN,OUT]:传入int指针，返回实际接收的数据长度
return:
    成功:返回接收的字符串长度
    失败:小于0
*/
extern int psms_recv(int socketFd, char **data, int *datasize);

/*
des:
    与管理平台通信的tcp发送方法
param:
    socketFd[IN]:发送的套接字
    data[IN]:发送的数据内容
    datasize[IN]:发送的数据内容长度
return:
    成功:返回发送的字符串长度
    失败:小于0
*/
extern int psms_tcp_send(int socketFd, char *data, int datasize);

/*
des:
    与管理平台通信的数据接收方法
param:
    socketFd[IN]:接收套接字
    data[IN,OUT]:传入空字符串指针地址，返回接收的数据内容
    datasize[IN,OUT]:传入int指针，返回实际接收的数据长度
return:
    成功:返回接收的字符串长度
    失败:小于0
*/
extern int psms_recv(int socketFd, char **data, int *datasize);

#endif