#ifndef __H_PROTOCOL_PARSE_H__
#define __H_PROTOCOL_PARSE_H__

#include "common.h"
#include <regex.h>
#include <pthread.h>
#include <unistd.h>
#include <sys/syscall.h>

#define RUN_FAILURE -1
#define RUN_SUCCESS 0

#define CLIENT_TIMEOUT_TIME (10)
#define START_FLAG (0x59)
#define END_FLAG (0x0d)
#define FILE_FLAG (0x2b)

#define DATE_END_FIRST (0x0d)
#define DATE_END_SECOND (0x0a)

#define FILE_UPLOAD_FIRST (0x31)
#define FILE_UPLOAD_SECOND (0x30)

#define FILE_DOWN_AND_SHOW_FIRST_OPTION (0x37)
#define FILE_DOWN_AND_SHOW_SECOND_OPTION (0x31)

#define FILE_DOWN_FIRST_OPTION (0x30)
#define FILE_DOWN_SECOND_OPTION (0x35)

#define SCREEN_CONTENT_FIRST_OPTION (0x37)
#define SCREEN_CONTENT_SECOND_OPTION (0x34)
#define SCREEN_LIST_FIRST_OPTION (0x35)
#define SCREEN_LIST_SECOND_OPTION (0x30)

#define CRC_AND_END_LEN (3)
#define FILE_DOWN_OPTION (1)
#define FILE_OFFSET (4)
#define LISTNUMBER_LEN (10)
#define SCREEN_CONTENT_OFFSET (16)
#define LISTNAME_AND_ITEMS_LEN (25)

#pragma pack(push, 1)
typedef struct _st_protocolHead
{
    // 帧起始符
    unsigned char startFlagFirst;
    // 帧起始符
    unsigned char startFlagSecond;
    // 目的地址域
    unsigned char detAddr;
    // 源地址域
    unsigned char srcAddr;
    // 指令码
    unsigned char orderCode[2];
    // 数据长度
    unsigned char dataLenFirst;
    // 数据长度
    unsigned char dataLenSecond;
    // 封包的总数量
    unsigned char maxBag;
    // 封包编号
    unsigned char maxNumber;
    // 封包大小
    unsigned char bagMode;
    // 幕号
    unsigned short pgNumber;

} ST_protocolHead, *PST_protocolHead;
typedef struct _st_protocolData
{
    // 数据域
    char *data;
    // 结束符
    unsigned char endFlag;
    // 校验码
    unsigned char crcCode;
} ST_protocolData, *PST_protocolData;

typedef struct _st_protocolEnd
{
    // 结束符
    unsigned char endFlag;
    // 校验码
    unsigned char crcCode;
} ST_protocolEnd, *PST_protocolEnd;
#pragma pack(pop)

/*
des:
    开启转发和解析工作
pram：
    param[IN]:提取的客户端连接
*/
void forword_and_parse(void *param);

#endif