#include "setting.h"
#include "common.h"
#include "policy.h"
#include "operate_file.h"

ST_globalInfo gglobalInfo;
ST_reportFileInfo reportFileInfo;
/*
des:
   鱼爪启动信息初始化
param:
   pocto_share[IN]:鱼头鱼爪共享信息
return:
   成功：等于0
   失败：小于0
*/
int init_leg_info(PST_octoShare poctoShare)
{
   int ret = -1;
   int tmpRet = -1;

   memset(&gglobalInfo, 0, sizeof(ST_globalInfo));
   memset(&reportFileInfo, 0, sizeof(ST_reportFileInfo));
   gglobalInfo.writeList = NULL;
   gglobalInfo.allowIpList = NULL;
   gglobalInfo.reviewWriteList = NULL;

   gglobalInfo.bmpWriteList = NULL;
   gglobalInfo.bmpReviewWriteList = NULL;

   gglobalInfo.writeList = xlist_init();
   if (gglobalInfo.writeList == NULL)
   {
      DBGPRINT(VERR, "init_leg_info() writeList xlist_init() error.");
      goto __finish;
   }
   gglobalInfo.reviewWriteList = xlist_init();
   if (gglobalInfo.reviewWriteList == NULL)
   {
      DBGPRINT(VERR, "init_leg_info() reviewWriteList xlist_init() error.");
      goto __finish;
   }
   gglobalInfo.allowIpList = xlist_init();
   if (gglobalInfo.allowIpList == NULL)
   {
      DBGPRINT(VERR, "init_leg_info() allowIpList xlist_init() error.");
      goto __finish;
   }
   gglobalInfo.bmpWriteList = xlist_init();
   if (gglobalInfo.bmpWriteList == NULL)
   {
      DBGPRINT(VERR, "init_leg_info() bmpWriteList xlist_init() error.");
      goto __finish;
   }
   
   gglobalInfo.bmpReviewWriteList = xlist_init();
   if (gglobalInfo.bmpReviewWriteList == NULL)
   {
      DBGPRINT(VERR, "init_leg_info() bmpReviewWriteList xlist_init() error.");
      goto __finish;
   }
   
   gglobalInfo.tmpReviewWirteList = xlist_init();
   if (gglobalInfo.tmpReviewWirteList == NULL)
   {
      DBGPRINT(VERR, "init_leg_info() tmpReviewWirteList xlist_init() error.");
      goto __finish;
   }

   gglobalInfo.bmpTmpReviewWirteList = xlist_init();
   if (gglobalInfo.bmpTmpReviewWirteList == NULL)
   {
      DBGPRINT(VERR, "init_leg_info() tmpReviewWirteList xlist_init() error.");
      goto __finish;
   }


   memcpy(&gglobalInfo.octoShare, poctoShare, sizeof(ST_octoShare));

   // 初始化线程锁
   pthread_mutex_init(&(gglobalInfo.threadMutex), NULL);

   // 初始化屏幕内容记录文件锁
   pthread_mutex_init(&(gglobalInfo.screenFileMutex), NULL);

   DBGPRINT(VDBG, "init_leg_info() head_path[%s].", gglobalInfo.octoShare.headPath);

   ret = 0;
__finish:
   return ret;
}

/*
des:
   释放鱼爪垃圾数据
param:
   pocto_share[IN]:鱼头鱼爪共享信息
*/

extern void yh_free_sockets(void);

void free_leg_info(PST_octoShare poctoShare)
{
    yh_free_sockets();
}

