#ifndef __H_YUANHENG_H__
#define __H_YUANHENG_H__
#include <stdio.h>
#include <string.h>
#include "afx/m_afx.h"
#include "afx/xcjson.h"
#include "afx/xrelloc.h"
#include "afx/xbase64.h"
#include "afx/xmd5.h"
#include "common.h"
#include "protocol_parse.h"
#include "setting.h"
#include <pthread.h>
#include <unistd.h>
#include <sys/syscall.h>
#include <arpa/inet.h>
#include "packet.h"

#define START_FLAG (0x59)
#define END_FLAG (0x0d)
#define FILE_FLAG (0x2b)
#define CONVERT_FLAG (0x1b)
#define FILE_FLAG_LEN (1)
#define FILE_OFFSET_LEN (4)
#define PACKET_DATA_LEN (512)
#define PACKET_HEAD_LEN (8)

/*
des:
    解析数据包
parm：
    buf[IN]:数据包内容
    bufSize[IN]:数据包长度
return:
    0:阻断转发，需处理业务
    小于0:数据包通过
*/
extern int parse_client_packet(char *buf, int bufSize);
extern int parse_server_packet(char *buf, int bufSize);
/*
des:
    从数据包中获取列表名
parm：
    buf[IN]:数据内容
    bufSize[IN,OUT]:
return:
    0:需要创建
    小于0：不需要创建
*/
extern void grep_need_to_create_file(unsigned char *buf, int bufSize, int *createFileFlag);

/*
des:
    解析图片内容
param：
    buf[IN]:数据包内容
    bufSize[IN]:数据包大小
    fileNameLen[IN]:该数据包文件名
    jsonRoot[IN,OUT]:json根
return:
    0:接收完毕
    小于:需接续接收
*/
extern int parse_bmp(unsigned char *buf, int bufSize, int createFileFlag);

#endif